#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 CLR_NONE
//---- indicator parameters
//extern string Description= "1=161.8; 2=261.8; 3=423.6; 4=685.4;"; 
extern double ExtDepth=161.8;       
extern double ExtDeviation=0.5;
extern int ExtBackstep=3;
//---- indicator buffers
double ExtMapBuffer[];
double ExtMapBuffer2[];

int OldLastZigZag, OldPreviousZigZag;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION,3);  //Zig Zag Line; 0 = Line true, 1 =  line false
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(0,0.0);
   ArraySetAsSeries(ExtMapBuffer,true);
   ArraySetAsSeries(ExtMapBuffer2,true);
   
//---- initialization done
   return(0);
  }
  
int deinit() {
	ObjectDelete("Weekly");
 
  ObjectDelete ("76.4% Weekly S/R ");
  ObjectDelete("50.0% Weekly S/R ");
  ObjectDelete("61.8% Weekly S/R ");
  ObjectDelete("38.2% Weekly S/R ");
  ObjectDelete ("23.6% Weekly S/R ");
  ObjectDelete ("0.00% Weekly S/R ");
 

}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    shift, back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;

   for(shift=Bars-ExtDepth; shift>=0; shift--)
     {
      val=Low[Lowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer[shift+back];
               if((res!=0)&&(res>val)) ExtMapBuffer[shift+back]=0.0; 
              }
           }
        } 
      ExtMapBuffer[shift]=val;
      //--- high
      val=High[Highest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer2[shift+back];
               if((res!=0)&&(res<val)) ExtMapBuffer2[shift+back]=0.0; 
              } 
           }
        }
      ExtMapBuffer2[shift]=val;
     }

   // final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(shift=Bars-ExtDepth; shift>=0; shift--)
     {
      curlow=ExtMapBuffer[shift];
      curhigh=ExtMapBuffer2[shift];
      if((curlow==0)&&(curhigh==0)) continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh>0) 
           {
            if(lasthigh<curhigh) ExtMapBuffer2[lasthighpos]=0;
            else ExtMapBuffer2[shift]=0;
           }
         //---
         if(lasthigh<curhigh || lasthigh<0)
           {
            lasthigh=curhigh;
            lasthighpos=shift;
           }
         lastlow=-1;
        }
      //----
      if(curlow!=0)
        {
         if(lastlow>0)
           {
            if(lastlow>curlow) ExtMapBuffer[lastlowpos]=0;
            else ExtMapBuffer[shift]=0;
           }
         //---
         if((curlow<lastlow)||(lastlow<0))
           {
            lastlow=curlow;
            lastlowpos=shift;
           } 
         lasthigh=-1;
        }
     }
  
   for(shift=Bars-1; shift>=0; shift--)
     {
      if(shift>=Bars-ExtDepth) ExtMapBuffer[shift]=0.0;
      else
        {
         res=ExtMapBuffer2[shift];
         if(res!=0.0) ExtMapBuffer[shift]=res;
        }

     } 
     
   int i=0;
  	int LastZigZag, PreviousZigZag;
   
   int h=0;
   while ( ExtMapBuffer[h]==0 && ExtMapBuffer[h]==0) {
   	h++;
   }
   
   LastZigZag=h;
   
   h++;
   while(ExtMapBuffer[h]==0 && ExtMapBuffer2[h]==0) {
   	h++;
   }
   
   PreviousZigZag=h;
   
   if (LastZigZag!=OldLastZigZag || PreviousZigZag!=OldPreviousZigZag) {
   	
   	OldLastZigZag=LastZigZag;
   	OldPreviousZigZag=PreviousZigZag;
     
   if (LastZigZag!=OldLastZigZag || PreviousZigZag!=OldPreviousZigZag) {
   	
   	OldLastZigZag=LastZigZag;
   	OldPreviousZigZag=PreviousZigZag;
   	
      WindowRedraw();                            //time1  price         time2        price 2  
      ObjectCreate("Weekly", OBJ_FIBO, 0, Time[PreviousZigZag], ExtMapBuffer[PreviousZigZag], 
                                                   Time[LastZigZag], ExtMapBuffer[LastZigZag]);}
      
    	ObjectDelete("Weekly");
   	ObjectCreate("Weekly", OBJ_FIBO, 0, Time[PreviousZigZag], ExtMapBuffer[PreviousZigZag], 
   	                                             Time[LastZigZag], ExtMapBuffer[LastZigZag]);
     
      double fiboPrice1=ObjectGet("Weekly",OBJPROP_PRICE1);
      double fiboPrice2=ObjectGet("Weekly",OBJPROP_PRICE2);
     
      double   FIBO236   = fiboPrice2 + 0.236 * (fiboPrice1 - fiboPrice2);// price at  23.6
      double   FIBO382   = fiboPrice2 + 0.382 * (fiboPrice1 - fiboPrice2);// price at  38.2 
      double   FIBO50    = fiboPrice2 + 0.50  * (fiboPrice1 - fiboPrice2);// price at  50.0 
      double   FIBO618   = fiboPrice2 + 0.618 * (fiboPrice1 - fiboPrice2);// price at  61.8
      double   FIBO764   = fiboPrice2 + 0.764 * (fiboPrice1 - fiboPrice2);// price at  76.4
     // double   FIBO123   = fiboPrice2 + 1.236 * (fiboPrice1 - fiboPrice2);// price at  123.6
     ObjectSet("Weekly",OBJPROP_FIBOLEVELS,6);
     ObjectSet("Weekly",OBJPROP_FIRSTLEVEL+0,0.236);
     ObjectSet("Weekly",OBJPROP_FIRSTLEVEL+2,0.382);
     ObjectSet("Weekly",OBJPROP_FIRSTLEVEL+3,0.50);
     ObjectSet("Weekly",OBJPROP_FIRSTLEVEL+4,0.618);
     ObjectSet("Weekly",OBJPROP_FIRSTLEVEL+5,0.764);
  
     ObjectSet("Weekly",OBJPROP_COLOR,EMPTY);
     ObjectSet("Weekly",OBJPROP_LEVELCOLOR,EMPTY);
     ObjectSet("Weekly",OBJPROP_LEVELWIDTH,2);
     ObjectSet("Weekly",OBJPROP_LEVELSTYLE,STYLE_SOLID);
     /*ObjectSetFiboDescription( "Fibonacci Linesx", 5,"23.6>                      ");
     ObjectSetFiboDescription( "Fibonacci Linesx", 4,"61.8>                      "); 
     ObjectSetFiboDescription( "Fibonacci Linesx", 3,"50.0>                      ");
     ObjectSetFiboDescription( "Fibonacci Linesx", 2,"38.2>                      ");
     ObjectSetFiboDescription( "Fibonacci Linesx", 0,"76.4>                      ");/*
    
  
  //----
        /* if(ObjectFind("123.6% midterm ") != 0)
         { 
           ObjectCreate("123.6% midterm ", OBJ_HLINE, 0, Time[0], FIBO123);//Neds to be previus zigzag  
           ObjectSet("123.6% midterm ", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("123.6% midterm ", OBJPROP_COLOR, Red);
         }
       else
         {
           ObjectMove("123.6% midterm ", 0, Time[0], FIBO123);
         }*/
  
  
  
  //----
         if(ObjectFind("76.4% Weekly S/R ") != 0)
         {
           ObjectCreate("76.4% Weekly S/R ", OBJ_HLINE, 0, Time[0], FIBO764);
           ObjectSet("76.4% Weekly S/R ", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("76.4% Weekly S/R ", OBJPROP_COLOR, Red);
         }
       else
         {
           ObjectMove("76.4% Weekly S/R ", 0, Time[0], FIBO764);
         }
      
 //----
         if(ObjectFind("23.6% Weekly S/R ") != 0)
         {
           ObjectCreate("23.6% Weekly S/R ", OBJ_HLINE, 0, Time[0], FIBO236);
           ObjectSet("23.6% Weekly S/R ", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("23.6% Weekly S/R ", OBJPROP_COLOR, Red);
         }
       else
         {
           ObjectMove("23.6% Weekly S/R ", 0, Time[0], FIBO236);
         }
       //----
      
      //----
         if(ObjectFind("38.2% Weekly S/R ") != 0)
         {
           ObjectCreate("38.2% Weekly S/R ", OBJ_HLINE, 0, Time[0], FIBO382);
           ObjectSet("38.2% Weekly S/R ", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("38.2% Weekly S/R ", OBJPROP_COLOR, Red);
         }
       else
         {
           ObjectMove("38.2% Weekly S/R ", 0, Time[0], FIBO382);
         }
       //----
       if(ObjectFind("50.0% Weekly S/R ") != 0)
         {
           ObjectCreate("50.0% Weekly S/R ", OBJ_HLINE, 0, Time[0], FIBO50);
           ObjectSet("50.0% Weekly S/R ", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("50.0% Weekly S/R ", OBJPROP_COLOR, Red);
         }
       else
         {
           ObjectMove("50.0% Weekly S/R ", 0, Time[0], FIBO50);
         }
       //----
   if(ObjectFind("61.8% Weekly S/R ") != 0)
         {
           ObjectCreate("61.8% Weekly S/R ", OBJ_HLINE, 0, Time[0], FIBO618);
           ObjectSet("61.8% Weekly S/R ", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("61.8% Weekly S/R ", OBJPROP_COLOR, Red);
         }
       else
         {
           ObjectMove("61.8% Weekly S/R ", 0, Time[0], FIBO618);
         }
       //----
   
   
   }                               
}                                  
  
   